searchNodes=[{"doc":"Tools for operating on versioned records.","ref":"Versioned.html","title":"Versioned","type":"module"},{"doc":"Deletes a struct using its primary key and adds a deleted version.","ref":"Versioned.html#delete/2","title":"Versioned.delete/2","type":"function"},{"doc":"Get a version for a schema module. Options can include anything used by the repo's get/3 .","ref":"Versioned.html#get/3","title":"Versioned.get/3","type":"function"},{"doc":"List all versions for a schema module, newest first. History will be found based on a module name and id or pass in a struct. Options can include anything used by the repo's all/2 and history_query/3 .","ref":"Versioned.html#history/3","title":"Versioned.history/3","type":"function"},{"doc":"Get the query to fetch all the versions for a schema, newest first. Options :limit - Max number of records to return. Default: return all records.","ref":"Versioned.html#history_query/3","title":"Versioned.history_query/3","type":"function"},{"doc":"Inserts a versioned struct defined via Ecto.Schema or a changeset. This function calls to the Ecto.Repo module twice -- once to insert the record itself, and once to insert a copy as the first version in the versions table.","ref":"Versioned.html#insert/2","title":"Versioned.insert/2","type":"function"},{"doc":"Get the timestamp for the very first version of this entity.","ref":"Versioned.html#inserted_at/1","title":"Versioned.inserted_at/1","type":"function"},{"doc":"Preload version associations. Example iex&gt; pv = Repo . get ( Person.Version , &quot;7f85b58b-ef57-4288-ade0-ff47f0ceb116&quot; ) iex&gt; Versioned . preload ( pv , :fancy_hobby_versions ) % Person.Version { id : &quot;7f85b58b-ef57-4288-ade0-ff47f0ceb116&quot; , fancy_hobby_versions : [ %{ id : &quot;a2a911fb-e2a6-459c-93e2-616be0fa1a45&quot; , name : &quot;Jenga&quot; } ] }","ref":"Versioned.html#preload/2","title":"Versioned.preload/2","type":"function"},{"doc":"Updates a changeset (of a versioned schema) using its primary key. This function uses the Ecto.Repo module, first calling update/2 to update the record itself, and then insert/1 to add a copy of the new version to the versions table.","ref":"Versioned.html#update/2","title":"Versioned.update/2","type":"function"},{"doc":"True if the given module or struct is a version.","ref":"Versioned.html#version?/1","title":"Versioned.version?/1","type":"function"},{"doc":"Get the version module from the subject module.","ref":"Versioned.html#version_mod/1","title":"Versioned.version_mod/1","type":"function"},{"doc":"True if the Ecto.Schema module is versioned. This means there is a corresponding Ecto.Schema module with an extra &quot;.Version&quot; on the end.","ref":"Versioned.html#versioned?/1","title":"Versioned.versioned?/1","type":"function"},{"doc":"Build the query to populate the :version_id virtual field on a versioned entity. query may be any existing base query for the entity which is versioned. mod , if defined, should be the entity module name itself. If not defined, query must be this module name and not any type of query.","ref":"Versioned.html#with_versions/2","title":"Versioned.with_versions/2","type":"function"},{"doc":"Helpers for Absinthe schemas.","ref":"Versioned.Absinthe.html","title":"Versioned.Absinthe","type":"module"},{"doc":"Create a version wrapper object type, name , wrapping a certain object type, wrapped_name . The caller should use Absinthe.Schema.Notation as here we return code which invokes its object macro. The generated object will have the following fields: :id - primary key of the version record :is_deleted - boolean indicating if the record was deleted as of this version :inserted_at - UTC timestamp, indicating when the version was created field specified by wrapped_name - The object as it was in this version","ref":"Versioned.Absinthe.html#version_object/3","title":"Versioned.Absinthe.version_object/3","type":"macro"},{"doc":"Tools shared between modules. (For internal use.)","ref":"Versioned.Helpers.html","title":"Versioned.Helpers","type":"module"},{"doc":"Create a version_mod struct to insert from a new instance of the record. Options :deleted - If true , records will marked as deleted. :change - For updates, an Ecto.Changeset.t/0 should be provided to inform which records were inserted vs updated vs deleted.","ref":"Versioned.Helpers.html#build_version/2","title":"Versioned.Helpers.build_version/2","type":"function"},{"doc":"Recursively crawl changeset and compile a list of version structs with is_deleted set to true.","ref":"Versioned.Helpers.html#deleted_versions/2","title":"Versioned.Helpers.deleted_versions/2","type":"function"},{"doc":"Wrap a line of AST in a block if it isn't already wrapped.","ref":"Versioned.Helpers.html#normalize_block/1","title":"Versioned.Helpers.normalize_block/1","type":"function"},{"doc":"Allows creating tables for versioned schemas. Example defmodule MyApp.Repo.Migrations.CreateCar do use Versioned.Migration def change do create_versioned_table ( :cars ) do add :name , :string end end end","ref":"Versioned.Migration.html","title":"Versioned.Migration","type":"module"},{"doc":"Add a new column to both the main table and the versions table.","ref":"Versioned.Migration.html#add_versioned_column/4","title":"Versioned.Migration.add_versioned_column/4","type":"macro"},{"doc":"Create a table whose data is versioned by also creating a secondary table with the immutable, append-only history.","ref":"Versioned.Migration.html#create_versioned_table/3","title":"Versioned.Migration.create_versioned_table/3","type":"macro"},{"doc":"Enhances Ecto.Schema modules to track a full history of changes. Example defmodule MyApp.Car do use Versioned.Schema versioned_schema &quot;cars&quot; do field :name , :string has_many :people , MyApp.Person , versioned : true end end","ref":"Versioned.Schema.html","title":"Versioned.Schema","type":"module"},{"doc":"","ref":"Versioned.Schema.html#version_before_compile/1","title":"Versioned.Schema.version_before_compile/1","type":"macro"},{"doc":"Convert a list of ast lines from the main schema into ast lines to be used for the version schema.","ref":"Versioned.Schema.html#version_lines/1","title":"Versioned.Schema.version_lines/1","type":"macro"},{"doc":"Create a versioned schema.","ref":"Versioned.Schema.html#versioned_schema/2","title":"Versioned.Schema.versioned_schema/2","type":"macro"},{"doc":"Versioned Versioned is a tool for enhancing Ecto.Schema modules to keep a full history of changes. The underlying method is to create a corresponding &quot;versions&quot; table for each schema (with all the same columns) where each record indicates a create, update, or delete event. When a record is deleted, the versions table entry has the record in its final state, and the special is_deleted field will be set to true. Records in the main table are mutable and operated on as normal, including deletes where the record is truly deleted. Versioned provides helpers for migrations and schemas. The Versioned module has insert/2 , update/2 and delete/2 which should be used in place of your application's Repo for versioned tables. Finally, history/3 can be used to retrieve a list of entity versions, newest first.","ref":"readme.html","title":"Versioned","type":"extras"},{"doc":"def deps do [ { :versioned , git : &quot;https://github.com/instinctscience/versioned.git&quot; , branch : &quot;main&quot; } ] end","ref":"readme.html#installation","title":"Versioned - Installation","type":"extras"},{"doc":"defmodule MyApp.Repo.Migrations.CreateCar do use Versioned.Migration def change do # Creates 2 tables: # - &quot;cars&quot; with columns id, name, inserted_at and updated_at # - &quot;cars_versions&quot; with columns id, name, car_id and inserted_at create_versioned_table ( :cars ) do add ( :name , :string ) end end end defmodule MyApp.Car do use Versioned.Schema versioned_schema &quot;cars&quot; do field ( :name , :string ) end end defmodule MyApp do alias MyApp.Car def do_some_stuff do { :ok , %{ id : car_id } = car } = Versioned . insert ( % Car { name : &quot;Toad&quot; } ) { :ok , car } = car |&gt; Ecto.Changeset . change ( ) |&gt; Ecto.Changeset . cast ( %{ name : &quot;Magnificent&quot; } , [ :name ] ) |&gt; Versioned . update ( ) { :ok , _car } = Versioned . delete ( car ) # The record is deleted. nil = MyApp.Repo . get ( Car , car_id ) # `Versioned.history/2` still returns all changes, newest first. [ % Car.Version { car_id : ^ car_id , name : &quot;Magnificent&quot; , is_deleted : true } , % Car.Version { car_id : ^ car_id , name : &quot;Magnificent&quot; , is_deleted : false } , % Car.Version { car_id : ^ car_id , name : &quot;Toad&quot; , is_deleted : false } ] = Versioned . history ( Car , car_id ) end end","ref":"readme.html#example","title":"Versioned - Example","type":"extras"},{"doc":"Also of note is the library's ability to properly manage version records when inserting, updating or deleting groups of records via has_many relationships with Ecto.Changeset.cast_assoc/3 . Note that creating or updating a single child record in the params for a belongs_to connection is not currently supported. In fact, there are probably other potentially useful features and pieces which have not yet been explored.","ref":"readme.html#managing-groups-of-records-together","title":"Versioned - Managing Groups of Records Together","type":"extras"},{"doc":"Migration Helper: Add Column on a Versioned Table Later, add a new column in a migration with this convenience macro which appropriately adds the field to both tables. defmodule MyApp.Repo.Migrations.AddCarColor do use Versioned.Migration def change do add_versioned_column ( :cars , :color , :string ) end end Absinthe Helper: Create a Version Object While versioned does not depend on Absinthe, it does provide a shortcut for creating an absinthe &quot;version&quot; object, wrapping one of your entities. In the following example, :car_version would have the following fields: :id - primary key of the version record :is_deleted - boolean indicating if the record was deleted as of this version :inserted_at - UTC timestamp, indicating when the version was created :car - The car as it was in this version defmodule MyApp.Schema.Types.User do use Absinthe.Schema.Notation import Versioned.Absinthe object :car do field :id , :id field :name , :string end version_object :car_version , :car end","ref":"readme.html#extras","title":"Versioned - Extras","type":"extras"}]